package de.intevation.gnv.exports;

import java.util.Collection;
import java.util.List;

import java.io.OutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import de.intevation.gnv.transition.exception.TransitionException;

/**
 * @author Sascha L. Teichmann (sascha.teichmann@intevation.de)
 * @author Ingo Weinzierl (ingo.weinzierl@intevation.de)
 */
public interface Export {

    public interface Profile {
        String getHeader(int column);
        int    numberColumns();
        String toString(int column, String value);
        char   getSeparator();
        char   getEscapeCharacter();
        char   getQuoteCharacter();
        String getType();
        String getEncoding();
    }

    public void create(
        Profile      profile,
        OutputStream outputStream, 
        Collection   result
    )
    throws IOException, UnsupportedEncodingException, TransitionException;

}
